package com.outr.webcommunicator.netty.handler

import com.outr.webcommunicator.netty.NettyWebapp
import org.jboss.netty.channel.{MessageEvent, ChannelHandlerContext}
import org.jboss.netty.handler.codec.http.HttpRequest

/**
 * @author Matt Hicks <mhicks@powerscala.org>
 */
abstract class AJAXHandler extends RequestHandler {
  protected var context: ChannelHandlerContext = null
  protected var request: HttpRequest = null

  def apply(webapp: NettyWebapp, context: ChannelHandlerContext, event: MessageEvent) = event.getMessage match {
    case request: HttpRequest => {
      this.context = context
      this.request = request
      handle(context, request)
    }
  }

  def handle(context: ChannelHandlerContext, request: HttpRequest): Unit
}
